Index: /trunk/src/sh_files.c
===================================================================
--- /trunk/src/sh_files.c	(revision 584)
+++ /trunk/src/sh_files.c	(revision 1)
@@ -20,42 +20,7 @@
 #include "config_xor.h"
 
-#if defined(HAVE_PTHREAD_MUTEX_RECURSIVE) && defined(HAVE_DIRENT_H) && defined(HAVE_SCANDIR)
-
-/* Linux */
-#if defined(__linux__)
-#define _XOPEN_SOURCE 700
-#define SH_USE_SCANDIR 1
-
-/* FreeBSD */
-#elif defined(__FreeBSD__)
-
-#if __FreeBSD__ >= 8
-#define __XSI_VISIBLE 700
-#define SH_USE_SCANDIR 1
-#endif
-
-/* OpenBSD */
-#elif defined(__OpenBSD__)
-#define __POSIX_VISIBLE 200809
-#define SH_USE_SCANDIR 1
-
-#elif defined(__NetBSD__)
-#define _NETBSD_SOURCE
-#define SH_USE_SCANDIR 1
-
-/* other os */
-#else
-#define _XOPEN_SOURCE 500
-
-#endif
-
-#elif defined(HAVE_PTHREAD_MUTEX_RECURSIVE)
-#define _XOPEN_SOURCE 500
-#endif
-
 #include <stdio.h>
 #include <stdlib.h>
 #include <string.h>
-#include <ctype.h>
 #include <limits.h>
 
@@ -66,14 +31,7 @@
 #include <sys/types.h>
 #include <unistd.h>
-#include <sys/stat.h>
-#include <fcntl.h>
-
-#if !defined(O_NOATIME)
-#if defined(__linux__) && (defined(__i386__) || defined(__x86_64__) || defined(__PPC__))
-#define O_NOATIME 01000000
-#endif
-#endif
 
 #include <utime.h>
+
 
 #ifdef HAVE_DIRENT_H
@@ -93,13 +51,8 @@
 #endif
 #endif
-#define NEED_ADD_DIRENT
 
 #ifdef HAVE_GLOB_H
 #include <glob.h>
 #endif
-#ifdef HAVE_FNMATCH_H
-#include <fnmatch.h>
-#endif
-
 
 #include "samhain.h"
@@ -107,5 +60,4 @@
 #if (defined (SH_WITH_CLIENT) || defined (SH_STANDALONE)) 
 
-#include "sh_pthread.h"
 #include "sh_error.h"
 #include "sh_utils.h"
@@ -115,170 +67,15 @@
 #include "sh_hash.h"
 #include "sh_ignore.h"
-#include "sh_inotify.h"
 #include "zAVLTree.h"
-#include "sh_dbIO.h"
 
 #undef  FIL__
 #define FIL__  _("sh_files.c")
 
-extern sh_watches sh_file_watches;
-
-static char * sh_files_C_dequote (char * s, size_t * length)
-{
-  size_t i, len = *length;
-  int    flag = 0;
-  char  *p, *q, *po, *pend;
-  
-  /* search for backslash
-   */
-  for (i = 0; i < len; ++i)
-    {
-      if (s[i] == '\\')
-	{
-	  flag = 1;
-	  break;
-	}
-    }
-
-  if (flag == 0 || *s == '\0')
-    return s;
-
-  po = SH_ALLOC(len+1); *po = '\0'; p = po; pend = &po[len];
-
-  q = s;
-
-  do
-    {
-      if (*q == '\\')
-	{
-	  ++q;
-
-	  if (*q == '\0')
-	    { *p = *q; flag = 0; break; }
-	  else if (*q == 'a')
-	    { *p = '\a'; ++p; ++q; }
-	  else if (*q == 'b')
-	    { *p = '\b'; ++p; ++q; }
-	  else if (*q == 'f')
-	    { *p = '\f'; ++p; ++q; }
-	  else if (*q == 'n')
-	    { *p = '\n'; ++p; ++q; }
-	  else if (*q == 'r')
-	    { *p = '\r'; ++p; ++q; }
-	  else if (*q == 't')
-	    { *p = '\t'; ++p; ++q; }
-	  else if (*q == 'v')
-	    { *p = '\v'; ++p; ++q; }
-	  else if (*q == '\\')
-	    { *p = '\\'; ++p; ++q; }
-	  else if (*q == '\'')
-	    { *p = '\''; ++p; ++q; }
-	  else if (*q == '"')
-	    { *p = '"';  ++p; ++q; }
-	  else if (*q == 'x')
-	    {
-	      if (isxdigit((int) q[1]) && isxdigit((int) q[2]))
-		{
-		  /* hexadecimal value following */
-		  unsigned char cc = (16 * sh_util_hexchar(q[1])) 
-		    + sh_util_hexchar(q[2]);
-		  *p = (char) cc;
-		  ++p; q += 3;
-		}
-	      else
-		{
-		  *p = '\0'; flag = 0; break;
-		}
-	    }
-	  else if (isdigit((int)*q))
-	    {
-	      if (isdigit((int) q[1]) && q[1] < '8' && 
-		  isdigit((int) q[2]) && q[2] < '8')
-		{
-		  /* octal value following */
-		  char tmp[4];  unsigned char cc;
-		  tmp[0] = *q; ++q; tmp[1] = *q; ++q; tmp[2] = *q; ++q; 
-		  tmp[3] = '\0';
-		  cc = strtol(tmp, NULL, 8);
-		  *p = (char) cc; ++p;
-		}
-	      else
-		{
-		  *p = '\0'; flag = 0; break;
-		}
-	    }
-	  else
-	    {
-	      /* invalid escape sequence */
-	      *p = '\0'; flag = 0; break;
-	    }
-	}
-      else
-	{
-	  *p = *q; 
-	  ++p; ++q;
-	}
-    } while (*q && p <= pend);
-
-  SL_REQUIRE (p <= pend, _("p <= pend"));
-
-  if (flag)
-    {
-      *p = '\0';
-      *length = strlen(po);
-    }
-  else
-    {
-      SH_FREE(po);
-      po = NULL;
-      *length = 0;
-    }
-
-  SL_REQUIRE (*length <= len, _("*length <= len"));
-
-  SH_FREE(s);
-  return po;
-}
-
-char * sh_files_parse_input(const char * str_s, size_t * len)
-{
-  char  * p;
-  
-  if (!str_s || *str_s == '\0')
-    return NULL;
-
-  *len = sl_strlen(str_s);
-  if (sh.flag.checkSum == SH_CHECK_INIT)
-    {
-      size_t addspace = sh_dbIO_get_rootfs_len();
-      if (addspace != 0 && S_TRUE == sl_ok_adds (*len, addspace))
-	*len += addspace;
-    }
-  
-  if ( (str_s[0] == '"'  && str_s[*len-1] == '"' ) ||
-       (str_s[0] == '\'' && str_s[*len-1] == '\'') )
-    {
-      if (*len < 3)
-	return NULL;
-      --(*len);
-      p = sh_util_strdup_l(&str_s[1], *len);
-      p[*len-1] = '\0';
-      --(*len);
-    }
-  else
-    {
-      p = sh_util_strdup_l(str_s, *len);
-    }
-
-  p = sh_files_C_dequote(p, len);
-
-  return p;
-}
-
+extern int safe_logger (int signal, int method, pid_t thepid);
 
 extern int flag_err_debug;
 extern int flag_err_info;
 
-int sh_files_reportonce(const char * c)
+int sh_files_reportonce(char * c)
 {
   int i;
@@ -289,5 +86,5 @@
 }
     
-int sh_files_fulldetail(const char * c)
+int sh_files_fulldetail(char * c)
 {
   int i;
@@ -307,6 +104,4 @@
   long    NumCDev;
   long    NumBDev;
-  long    NumDoor;
-  long    NumPort;
   long    NumAll;
   long    TotalBytes;
@@ -317,9 +112,9 @@
   char                  * name;
   int                     class;
-  unsigned long           check_flags;
+  unsigned long           check_mask;
   int                     rdepth;
   short                   checked;
   short                   childs_checked;
-  short                   is_reported;
+  short                   reported;
   /* struct dirstack_entry * next; */
 } dirstack_t;
@@ -353,10 +148,4 @@
 }
 
-#define SH_LIST_FILE 0
-#define SH_LIST_DIR1 1
-#define SH_LIST_DIR2 2
-
-
-static int which_dirList = SH_LIST_DIR1;
 
 static zAVLTree * zdirListOne   = NULL;
@@ -364,13 +153,14 @@
 static zAVLTree * zfileList     = NULL;
 
-SH_MUTEX_STATIC(mutex_zfiles,      PTHREAD_MUTEX_INITIALIZER);
-SH_MUTEX_STATIC(mutex_zglob,       PTHREAD_MUTEX_INITIALIZER);
-SH_MUTEX_RECURSIVE(mutex_zdirs);
-
-static int        sh_files_fullpath  (const char * testdir, 
-				      const char * d_name, 
+
+static int        sh_files_fullpath  (char * testdir, char * d_name, 
 				      char * statpath);
-static int        sh_files_pushdir   (int class, const char * str_s);
-static int        sh_files_pushfile  (int class, const char * str_s);
+static int        sh_files_pushdir   (int class, char * str_s);
+static int        sh_files_pushfile  (int class, char * str_s);
+static int        sh_files_checkdir  (int class, int rdepth, char * dirName,
+				      char * relativeName);
+static ShFileType sh_files_filecheck (int class, char * dirName, 
+				      char * fileName, int * reported,
+				      int rsrcflag);
 
 static long MaxRecursionLevel = 0;
@@ -378,5 +168,5 @@
 /* set default recursion level
  */
-int sh_files_setrecursion (const char * flag_s)
+int sh_files_setrecursion (char * flag_s)
 {
   long flag = 0;
@@ -388,5 +178,5 @@
     SL_RETURN((-1), _("sh_files_setrecursion"));
 
-  if (sh.flag.opts == S_TRUE)  
+  if (sh.flag.opts == 1)  
     reject = 1;
 
@@ -402,120 +192,4 @@
 }
 
-static int handle_filecheck_ret(dirstack_t * ptr, char * tmp_in, int status)
-{
-  int fcount = 0;
-  char * tmp;
-
-  if (!tmp_in)
-    tmp = sh_util_safe_name (ptr->name);
-  else
-    tmp = tmp_in;
-
-  if (status == SH_FILE_UNKNOWN && (!SH_FFLAG_REPORTED_SET(ptr->is_reported)))
-    {
-      TPT(( 0, FIL__, __LINE__, _("msg=<file: %s> status=<%d>\n"), 
-	    tmp, status));
-      
-      if ( sh.flag.checkSum == SH_CHECK_INIT  || 
-	   sh_hash_have_it (ptr->name) >= 0)
-	{
-	  if (S_FALSE == sh_ignore_chk_del(ptr->name))
-	    {
-	      if (0 != hashreport_missing(ptr->name, 
-					  (ptr->class == SH_LEVEL_ALLIGNORE) ? 
-					  ShDFLevel[ptr->class] : 
-					  ShDFLevel[SH_ERR_T_FILE])) {
-		if (tmp == NULL) 
-		  tmp = sh_util_safe_name (ptr->name);
-		if (!sh_global_check_silent)
-		  sh_error_handle ((ptr->class == SH_LEVEL_ALLIGNORE) ? 
-				   ShDFLevel[ptr->class] : 
-				   ShDFLevel[SH_ERR_T_FILE],
-				   FIL__, __LINE__, 0, MSG_FI_MISS,
-				   tmp);
-		++sh.statistics.files_report;
-	      }
-	    }
-	}
-      else /* not there at init, and still missing */
-	{
-	  if (tmp == NULL) 
-	    tmp = sh_util_safe_name (ptr->name);
-	  sh_error_handle (SH_ERR_NOTICE,
-			   FIL__, __LINE__, 0,
-			   MSG_FI_FAIL,
-			   tmp);
-	}
-
-      if (sh.flag.checkSum != SH_CHECK_INIT) 
-	sh_hash_set_missing(ptr->name);
-
-      if (sh.flag.reportonce == S_TRUE)
-	SET_SH_FFLAG_REPORTED(ptr->is_reported);
-    }
-  else 
-    {
-      /* exists (status >= 0), but was missing (reported == TRUE)
-       */
-      if (status != SH_FILE_UNKNOWN && SH_FFLAG_REPORTED_SET(ptr->is_reported))
-	{
-	  CLEAR_SH_FFLAG_REPORTED(ptr->is_reported);
-	  sh_hash_clear_flag(ptr->name, SH_FFLAG_ENOENT);
-	}
-      
-      /* Catchall
-       */
-      else if (status == SH_FILE_UNKNOWN)
-	{
-	  /* Thu Mar  7 15:09:40 CET 2002 Make sure missing file
-	   * is reported if ptr->reported == S_TRUE because the
-	   * file has been added.
-	   */
-	  if (sh_hash_have_it (ptr->name) >= 0 && 
-	      !SH_FFLAG_REPORTED_SET(ptr->is_reported))
-	    {
-	      if (S_FALSE == sh_ignore_chk_del(ptr->name))
-		{
-		  if (0 != hashreport_missing(ptr->name, 
-					      (ptr->class == SH_LEVEL_ALLIGNORE) ? 
-					      ShDFLevel[ptr->class] : 
-					      ShDFLevel[SH_ERR_T_FILE])) {
-		    if (tmp == NULL) 
-		      tmp = sh_util_safe_name (ptr->name);
-		    if (!sh_global_check_silent)
-		      sh_error_handle ((ptr->class == SH_LEVEL_ALLIGNORE)? 
-				       ShDFLevel[ptr->class] : 
-				       ShDFLevel[SH_ERR_T_FILE],
-				       FIL__, __LINE__, 0, MSG_FI_MISS,
-				       tmp);
-		    ++sh.statistics.files_report;
-		  }
-		}
-
-	      /* delete from database
-	       */
-	      if (sh.flag.checkSum != SH_CHECK_INIT) 
-		sh_hash_set_missing(ptr->name);
-	    }
-	  else
-	    {
-	      if (tmp == NULL) 
-		tmp = sh_util_safe_name (ptr->name);
-	      sh_error_handle (SH_ERR_INFO, FIL__, __LINE__, 0,
-			       MSG_FI_FAIL,
-			       tmp);
-	      if (sh.flag.checkSum != SH_CHECK_INIT)
-		sh_hash_set_visited_true(ptr->name);
-	    }
-	}
-      
-      ++fcount;
-    }
-  if (!tmp_in)
-    SH_FREE(tmp);
-
-  return fcount;
-}
-
 
 unsigned long sh_files_chk ()
@@ -528,7 +202,6 @@
 
   dirstack_t * ptr;
-  char       * dir;
+  char       * base;
   char       * file;
-  int          tmp_reported;
   
   SL_ENTER(_("sh_files_chk"));
@@ -544,6 +217,6 @@
       if (ptr->checked == S_FALSE)
 	{
-	  dir  = sh_util_dirname (ptr->name);
-	  file = sh_util_basename (ptr->name);
+	  base = sh_util_basename (ptr->name);
+	  file = sh_util_filename (ptr->name);
 #if defined(WITH_TPT)
 	  tmp = sh_util_safe_name (ptr->name);
@@ -551,33 +224,124 @@
 
 	  
-	  if (flag_err_info == S_TRUE)
+	  if (flag_err_info == SL_TRUE)
 	    {
-	      char pstr[32];
 #if !defined(WITH_TPT)
 	      tmp = sh_util_safe_name (ptr->name);
 #endif
-	      sl_strlcpy(pstr, sh_hash_getpolicy(ptr->class), sizeof(pstr));
-	      sh_error_handle ((-1),  FIL__, __LINE__, 0, 
-			       MSG_FI_CHK, pstr, tmp);
+	      sh_error_handle ((-1),  FIL__, __LINE__, 0, MSG_FI_CHK,
+			       tmp);
 	    }
 
-	  if ((sh.flag.inotify & SH_INOTIFY_INSCAN) != 0)
-	    {
-	      sh_inotify_add_watch_later(ptr->name, &sh_file_watches, NULL,
-					 ptr->class, ptr->check_flags, 
-					 SH_INOTIFY_FILE, 0);
-	    }
-
 	  BREAKEXIT(sh_files_filecheck);
-	  tmp_reported = ptr->is_reported; /* fix aliasing warning */ 
-	  status = sh_files_filecheck (ptr->class, ptr->check_flags, dir, file, 
-				       &tmp_reported, 0);
-	  ptr->is_reported = tmp_reported;
+	  status = sh_files_filecheck (ptr->class, base, file, 
+				       (int *) &(ptr->reported), 0);
 	  
 	  TPT(( 0, FIL__, __LINE__, 
 		_("msg=<filecheck complete: %s> status=<%d> reported=<%d>\n"), 
-		tmp, status, ptr->is_reported));
-
-	  fcount += handle_filecheck_ret(ptr, tmp, status);
+		tmp, status, ptr->reported));
+
+	  if (status == SH_FILE_UNKNOWN && ptr->reported == S_FALSE) 
+	    {
+	      TPT(( 0, FIL__, __LINE__, _("msg=<file: %s> status=<%d>\n"), 
+		    tmp, status));
+
+	      if ( sh.flag.checkSum == SH_CHECK_INIT  || 
+		  sh_hash_have_it (ptr->name) >= 0)
+		{
+		  if (S_FALSE == sh_ignore_chk_del(ptr->name))
+		    {
+		      if (0 != hashreport_missing(ptr->name, 
+						  (ptr->class == SH_LEVEL_ALLIGNORE) ? 
+						  ShDFLevel[ptr->class] : 
+						  ShDFLevel[SH_ERR_T_FILE])) {
+			if (tmp == NULL) 
+			  tmp = sh_util_safe_name (ptr->name);
+			sh_error_handle ((ptr->class == SH_LEVEL_ALLIGNORE) ? 
+					 ShDFLevel[ptr->class] : 
+					 ShDFLevel[SH_ERR_T_FILE],
+					 FIL__, __LINE__, 0, MSG_FI_MISS,
+					 tmp);
+		      }
+		    }
+		}
+	      else /* not there at init, and still missing */
+		{
+		  if (tmp == NULL) 
+		    tmp = sh_util_safe_name (ptr->name);
+		  sh_error_handle (SH_ERR_NOTICE,
+				   FIL__, __LINE__, 0,
+				   MSG_FI_FAIL,
+				   tmp);
+		}
+#ifndef REPLACE_OLD
+	      /* this will tell that we have seen the file, and thus prevent
+	       * deletion from the database, resulting in an incomplete
+	       * message when the file reappears
+	       */
+	      if (sh.flag.checkSum != SH_CHECK_INIT) 
+		sh_hash_set_visited_true(ptr->name);
+#else
+	      if (sh.flag.checkSum != SH_CHECK_INIT) 
+		sh_hash_set_missing(ptr->name);
+#endif
+	      if (sh.flag.reportonce == S_TRUE)
+		ptr->reported = S_TRUE;
+	    }
+	  else 
+	    {
+	      /* exists (status >= 0), but was missing (reported == TRUE)
+	       */
+	      if (status != SH_FILE_UNKNOWN && ptr->reported == S_TRUE)
+		{
+		  ptr->reported = S_FALSE;
+		}
+	      /* Catchall
+	       */
+	      else if (status == SH_FILE_UNKNOWN)
+		{
+		  /* Thu Mar  7 15:09:40 CET 2002 Make sure missing file
+		   * is reported if ptr->reported == S_TRUE because the
+		   * file has been added.
+		   */
+		  if (sh_hash_have_it (ptr->name) >= 0)
+		    {
+		      if (S_FALSE == sh_ignore_chk_del(ptr->name))
+			{
+			  if (0 != hashreport_missing(ptr->name, 
+						      (ptr->class == SH_LEVEL_ALLIGNORE) ? 
+						      ShDFLevel[ptr->class] : 
+						      ShDFLevel[SH_ERR_T_FILE])) {
+			    if (tmp == NULL) 
+			      tmp = sh_util_safe_name (ptr->name);
+			    sh_error_handle ((ptr->class == SH_LEVEL_ALLIGNORE)? 
+					     ShDFLevel[ptr->class] : 
+					     ShDFLevel[SH_ERR_T_FILE],
+					     FIL__, __LINE__, 0, MSG_FI_MISS,
+					     tmp);
+			  }
+			}
+#ifndef REPLACE_OLD
+		      if (sh.flag.checkSum != SH_CHECK_INIT) 
+			sh_hash_set_visited_true(ptr->name);
+#else
+		      /* delete from database
+		       */
+		      if (sh.flag.checkSum != SH_CHECK_INIT) 
+			sh_hash_set_missing(ptr->name);
+#endif
+		    }
+		  else
+		    {
+		      if (tmp == NULL) 
+			tmp = sh_util_safe_name (ptr->name);
+		      sh_error_handle (SH_ERR_INFO, FIL__, __LINE__, 0,
+				       MSG_FI_FAIL,
+				       tmp);
+		      if (sh.flag.checkSum != SH_CHECK_INIT)
+			sh_hash_set_visited_true(ptr->name);
+		    }
+		}
+	      ++fcount;
+	    }
 	  
 	  if (tmp != NULL)
@@ -586,8 +350,6 @@
 	      tmp = NULL;
 	    }
-	  if (file)
-	    SH_FREE(file);
-	  if (dir)
-	    SH_FREE(dir);
+	  SH_FREE(file);
+	  SH_FREE(base);
 
 	  ptr->checked = S_TRUE;
@@ -598,116 +360,10 @@
 }
 
-static zAVLTree * fileTree = NULL;
-static zAVLTree * dirTree  = NULL;
-
-static void clear_lists()
-{
-  if (fileTree) {
-    zAVL_string_reset(fileTree);
-    fileTree  = NULL;
-  }
-  if (dirTree) {
-    zAVL_string_reset(dirTree);
-    dirTree  = NULL;
-  }
-  return;
-}
-
-static void add_to_filelist(zAVLTree * tree)
-{
-  dirstack_t * ptr;
-  zAVLCursor   avlcursor;
-
-  SL_ENTER(_("add_to_filelist"));
-
-  SH_MUTEX_LOCK(mutex_zfiles);
-  for (ptr = (dirstack_t *) zAVLFirst(&avlcursor, tree); ptr;
-       ptr = (dirstack_t *) zAVLNext(&avlcursor))
-    zAVL_string_set (&fileTree, ptr->name);
-  SH_MUTEX_UNLOCK(mutex_zfiles);
-  SL_RET0(_("add_to_filelist"));
-}
-static void add_to_dirlist(zAVLTree * tree)
-{
-  dirstack_t * ptr;
-  zAVLCursor   avlcursor;
-
-  SL_ENTER(_("add_to_dirlist"));
-
-  SH_MUTEX_LOCK(mutex_zfiles);
-  for (ptr = (dirstack_t *) zAVLFirst(&avlcursor, tree); ptr;
-       ptr = (dirstack_t *) zAVLNext(&avlcursor))
-    zAVL_string_set (&dirTree, ptr->name);
-  SH_MUTEX_UNLOCK(mutex_zfiles);
-  SL_RET0(_("add_to_dirlist"));
-}
-char * sh_files_findfile(const char * path)
-{
-  return zAVL_string_get (fileTree, path);
-}
-
-void * sh_dummy_621_candidate;
-
-static char * intern_find_morespecific_dir(zAVLTree * tree, 
-					   const char * path, size_t * len)
-{
-  dirstack_t * ptr;
-  zAVLCursor   avlcursor;
-  size_t       l_path = strlen(path);
-  size_t       l_name;
-  char *       candidate = NULL;
-  volatile size_t       l_candidate = 0;
-  
-  if (NULL == tree)
-    return NULL;
-
-  sh_dummy_621_candidate = (void *) &candidate;
-
-  SH_MUTEX_LOCK(mutex_zfiles);
-  for (ptr = (dirstack_t *) zAVLFirst(&avlcursor, tree); ptr;
-       ptr = (dirstack_t *) zAVLNext(&avlcursor))
-    {
-      l_name = strlen(ptr->name);
-      if (l_name <= l_path)
-	{
-	  if (0 == strncmp(ptr->name, path, l_name))
-	    {
-	      if ((l_name == l_path) || (path[l_name] == '/'))
-		{
-		  if (!candidate || (l_candidate < l_name))
-		    {
-		      candidate = ptr->name;
-		      l_candidate = l_name;
-		      *len = l_candidate;
-		    }
-		}
-	    }
-	}
-    }
-  SH_MUTEX_UNLOCK(mutex_zfiles);
-  return candidate;
-}
-char * sh_files_find_mostspecific_dir(const char * path)
-{
-  size_t l_one = 0;
-  size_t l_two = 0;
-  char * one;
-  char * two;
-
-  one = intern_find_morespecific_dir(zdirListOne, path, &l_one);
-  two = intern_find_morespecific_dir(zdirListTwo, path, &l_two);
-
-  if      (l_one > l_two) return one;
-  else                    return two;
-}
-
 int sh_files_delfilestack ()
 {
   SL_ENTER(_("sh_files_delfilestack"));
 
-  SH_MUTEX_LOCK(mutex_zfiles);
   zAVLFreeTree (zfileList, free_dirstack);
   zfileList = NULL;
-  SH_MUTEX_UNLOCK(mutex_zfiles);
 
   SL_RETURN(0, _("sh_files_delfilestack"));
@@ -728,8 +384,5 @@
 	    ptr->rdepth = MaxRecursionLevel;
 	  }
-
-	if ( (ptr->rdepth      == (-1)) && 
-	     (ptr->class       == SH_LEVEL_ALLIGNORE) && 
-	     (sh.flag.checkSum != SH_CHECK_INIT))
+	if (ptr->rdepth == (-1) && sh.flag.checkSum != SH_CHECK_INIT)
 	  hash_remove_tree (ptr->name);
       }
@@ -740,16 +393,6 @@
 int sh_files_setrec ()
 {
-  volatile int ret;
-  SH_MUTEX_RECURSIVE_INIT(mutex_zdirs);
-  SH_MUTEX_RECURSIVE_LOCK(mutex_zdirs);
-  clear_lists();
-  add_to_dirlist(zdirListOne);
-  add_to_dirlist(zdirListTwo);
-  add_to_filelist(zfileList);
   sh_files_setrec_int(zdirListOne);
-  ret = sh_files_setrec_int(zdirListTwo);
-  SH_MUTEX_RECURSIVE_UNLOCK(mutex_zdirs);
-
-  return ret;
+  return sh_files_setrec_int(zdirListTwo);
 }
 
@@ -765,9 +408,6 @@
 int sh_files_deldirstack ()
 {
-  SH_MUTEX_RECURSIVE_INIT(mutex_zdirs);
-  SH_MUTEX_RECURSIVE_LOCK(mutex_zdirs);
   zdirListOne = sh_files_deldirstack_int(zdirListOne);
   zdirListTwo = sh_files_deldirstack_int(zdirListTwo);
-  SH_MUTEX_RECURSIVE_UNLOCK(mutex_zdirs);
   return 0;
 }
@@ -780,9 +420,8 @@
   SL_ENTER(_("sh_files_reset"));
 
-  SH_MUTEX_LOCK(mutex_zfiles);
   for (ptr = (dirstack_t *) zAVLFirst(&avlcursor, zfileList); ptr;
        ptr = (dirstack_t *) zAVLNext(&avlcursor))
     ptr->checked = 0;
-  SH_MUTEX_UNLOCK(mutex_zfiles);
+
   SL_RET0(_("sh_files_reset"));
 }
@@ -796,6 +435,4 @@
   SL_ENTER(_("sh_dirs_reset"));
 
-  SH_MUTEX_RECURSIVE_INIT(mutex_zdirs);
-  SH_MUTEX_RECURSIVE_LOCK(mutex_zdirs);
   for (ptr = (dirstack_t *) zAVLFirst(&avlcursor1, zdirListOne); ptr;
        ptr = (dirstack_t *) zAVLNext(&avlcursor1))
@@ -805,5 +442,4 @@
        ptr = (dirstack_t *) zAVLNext(&avlcursor2))
     ptr->checked = 0;
-  SH_MUTEX_RECURSIVE_UNLOCK(mutex_zdirs);
 
   SL_RET0(_("sh_dirs_reset"));
@@ -811,61 +447,47 @@
 
 
-int sh_files_pushfile_prelink (const char * str_s)
+int sh_files_pushfile_prelink (char * str_s)
 {
   return (sh_files_pushfile (SH_LEVEL_PRELINK, str_s));
 }
 
-int sh_files_pushfile_user0 (const char * str_s)
+int sh_files_pushfile_user0 (char * str_s)
 {
   return (sh_files_pushfile (SH_LEVEL_USER0, str_s));
 }
 
-int sh_files_pushfile_user1 (const char * str_s)
+
+int sh_files_pushfile_user1 (char * str_s)
 {
   return (sh_files_pushfile (SH_LEVEL_USER1, str_s));
 }
 
-int sh_files_pushfile_user2 (const char * str_s)
-{
-  return (sh_files_pushfile (SH_LEVEL_USER2, str_s));
-}
-
-int sh_files_pushfile_user3 (const char * str_s)
-{
-  return (sh_files_pushfile (SH_LEVEL_USER3, str_s));
-}
-
-int sh_files_pushfile_user4 (const char * str_s)
-{
-  return (sh_files_pushfile (SH_LEVEL_USER4, str_s));
-}
-
-
-int sh_files_pushfile_ro (const char * str_s)
+
+int sh_files_pushfile_ro (char * str_s)
 {
   return (sh_files_pushfile (SH_LEVEL_READONLY, str_s));
 }
 
-int sh_files_pushfile_attr (const char * str_s)
+int sh_files_pushfile_attr (char * str_s)
 {
   return (sh_files_pushfile (SH_LEVEL_ATTRIBUTES, str_s));
 }
 
-int sh_files_pushfile_log (const char * str_s)
+int sh_files_pushfile_log (char * str_s)
 {
   return (sh_files_pushfile (SH_LEVEL_LOGFILES, str_s));
 }
 
-int sh_files_pushfile_glog (const char * str_s)
+int sh_files_pushfile_glog (char * str_s)
 {
   return (sh_files_pushfile (SH_LEVEL_LOGGROW, str_s));
 }
 
-int sh_files_pushfile_noig (const char * str_s)
+int sh_files_pushfile_noig (char * str_s)
 {
   return (sh_files_pushfile (SH_LEVEL_NOIGNORE, str_s));
 }
 
-int sh_files_pushfile_allig (const char * str_s)
+int sh_files_pushfile_allig (char * str_s)
 {
   return (sh_files_pushfile (SH_LEVEL_ALLIGNORE, str_s));
@@ -890,5 +512,5 @@
 /* set mask(class)
  */
-static int sh_files_parse_mask (unsigned long * mask, const char * str)
+static int sh_files_parse_mask (unsigned long * mask, char * str)
 {
   int l, i = 0, act = 0, k = 0;
@@ -897,6 +519,4 @@
   SL_ENTER(_("sh_files_parse_mask"));
 
-  myword[0] = '\0';
-
   if (str == NULL)
     {
@@ -907,8 +527,6 @@
 
   while (i < l) {
-
     if (str[i] == '\0')
       break;
-
     if (str[i] == ' ' || str[i] == '\t' || str[i] == ',')
       {
@@ -920,16 +538,13 @@
       {
 	act = +1; ++i;
-	myword[0] = '\0';
-	goto getword;
+	continue;
       }
     else if (str[i] == '-')
       {
 	act = -1; ++i;
-	myword[0] = '\0';
-	goto getword;
+	continue;
       }
     else /* a word */
       {
-      getword:
 	k = 0;
 	while (k < 63 && str[i] != ' ' && str[i] != '\t' && str[i] != ','
@@ -940,63 +555,41 @@
 	myword[k] = '\0';
 
-	if (sl_strlen(myword) == 0)
-	  {
-	    SL_RETURN ( (-1), _("sh_files_parse_mask"));
-	  }
-
 /* checksum     */
-	if      (0 == strcmp(myword, _("CHK")))
+	if (0 == strncmp(myword, _("CHK"), 3))
 	  sh_files_set_mask (mask, MODI_CHK, act);
 /* link         */
-	else if (0 == strcmp(myword, _("LNK")))
+	if (0 == strncmp(myword, _("LNK"), 3))
 	  sh_files_set_mask (mask, MODI_LNK, act);
 /* inode        */
-	else if (0 == strcmp(myword, _("RDEV")))
+	if (0 == strncmp(myword, _("RDEV"), 3))
 	  sh_files_set_mask (mask, MODI_RDEV, act);
 /* inode        */
-	else if (0 == strcmp(myword, _("INO")))
+	if (0 == strncmp(myword, _("INO"), 3))
 	  sh_files_set_mask (mask, MODI_INO, act);
 /* user         */
-	else if (0 == strcmp(myword, _("USR")))
+	if (0 == strncmp(myword, _("USR"), 3))
 	  sh_files_set_mask (mask, MODI_USR, act);
 /* group        */
-	else if (0 == strcmp(myword, _("GRP")))
+	if (0 == strncmp(myword, _("GRP"), 3))
 	  sh_files_set_mask (mask, MODI_GRP, act);
 /* mtime        */
-	else if (0 == strcmp(myword, _("MTM")))
+	if (0 == strncmp(myword, _("MTM"), 3))
 	  sh_files_set_mask (mask, MODI_MTM, act);
 /* ctime        */
-	else if (0 == strcmp(myword, _("CTM")))
+	if (0 == strncmp(myword, _("CTM"), 3))
 	  sh_files_set_mask (mask, MODI_CTM, act);
 /* atime        */
-	else if (0 == strcmp(myword, _("ATM")))
+	if (0 == strncmp(myword, _("ATM"), 3))
 	  sh_files_set_mask (mask, MODI_ATM, act);
 /* size         */
-	else if (0 == strcmp(myword, _("SIZ")))
+	if (0 == strncmp(myword, _("SIZ"), 3))
 	  sh_files_set_mask (mask, MODI_SIZ, act);
 /* file mode    */
-	else if (0 == strcmp(myword, _("MOD")))
+	if (0 == strncmp(myword, _("MOD"), 3))
 	  sh_files_set_mask (mask, MODI_MOD, act);
 /* hardlinks    */
-	else if (0 == strcmp(myword, _("HLN")))
+	if (0 == strncmp(myword, _("HLN"), 3))
 	  sh_files_set_mask (mask, MODI_HLN, act);
-/* size may grow */
-	else if (0 == strcmp(myword, _("SGROW")))
-	  sh_files_set_mask (mask, MODI_SGROW, act);
-/* use prelink */
-	else if (0 == strcmp(myword, _("PRE")))
-	  sh_files_set_mask (mask, MODI_PREL, act);
-/* get content */
-	else if (0 == strcmp(myword, _("TXT")))
-	  sh_files_set_mask (mask, MODI_TXT, act);
-/* get audit report */
-	else if (0 == strcmp(myword, _("AUDIT")))
-	  sh_files_set_mask (mask, MODI_AUDIT, act);
-	else
-	  {
-	    SL_RETURN ( (-1), _("sh_files_parse_mask"));
-	  }
-	act       = 0;
-	myword[0] = '\0';
+	
       }
   }
@@ -1004,49 +597,37 @@
 }
 
-int sh_files_redef_prelink(const char * str)
+int sh_files_redef_prelink(char * str)
 {
   return (sh_files_parse_mask(&mask_PRELINK, str));
 } 
-int sh_files_redef_user0(const char * str)
+int sh_files_redef_user0(char * str)
 {
   return (sh_files_parse_mask(&mask_USER0, str));
 } 
-int sh_files_redef_user1(const char * str)
+int sh_files_redef_user1(char * str)
 {
   return (sh_files_parse_mask(&mask_USER1, str));
 } 
-int sh_files_redef_user2(const char * str)
-{
-  return (sh_files_parse_mask(&mask_USER2, str));
-} 
-int sh_files_redef_user3(const char * str)
-{
-  return (sh_files_parse_mask(&mask_USER3, str));
-} 
-int sh_files_redef_user4(const char * str)
-{
-  return (sh_files_parse_mask(&mask_USER4, str));
-} 
-int sh_files_redef_readonly(const char * str)
+int sh_files_redef_readonly(char * str)
 {
   return (sh_files_parse_mask(&mask_READONLY, str));
 } 
-int sh_files_redef_loggrow(const char * str)
+int sh_files_redef_loggrow(char * str)
 {
   return (sh_files_parse_mask(&mask_LOGGROW, str));
 } 
-int sh_files_redef_logfiles(const char * str)
+int sh_files_redef_logfiles(char * str)
 {
   return (sh_files_parse_mask(&mask_LOGFILES, str));
 } 
-int sh_files_redef_attributes(const char * str)
+int sh_files_redef_attributes(char * str)
 {
   return (sh_files_parse_mask(&mask_ATTRIBUTES, str));
 } 
-int sh_files_redef_noignore(const char * str)
+int sh_files_redef_noignore(char * str)
 {
   return (sh_files_parse_mask(&mask_NOIGNORE, str));
 } 
-int sh_files_redef_allignore(const char * str)
+int sh_files_redef_allignore(char * str)
 {
   return (sh_files_parse_mask(&mask_ALLIGNORE, str));
@@ -1058,27 +639,21 @@
     {
     case SH_LEVEL_READONLY:
-      return (unsigned long) (mask_READONLY | MODI_INIT);
+      return (unsigned long) mask_READONLY;
     case SH_LEVEL_ATTRIBUTES:
-      return (unsigned long) (mask_ATTRIBUTES | MODI_INIT);
+      return (unsigned long) mask_ATTRIBUTES;
     case SH_LEVEL_LOGFILES:
-      return (unsigned long) (mask_LOGFILES | MODI_INIT);
+      return (unsigned long) mask_LOGFILES;
     case SH_LEVEL_LOGGROW:
-      return (unsigned long) (mask_LOGGROW | MODI_INIT);
+      return (unsigned long) mask_LOGGROW;
     case SH_LEVEL_ALLIGNORE:
-      return (unsigned long) (mask_ALLIGNORE | MODI_INIT);
+      return (unsigned long) mask_ALLIGNORE;
     case SH_LEVEL_NOIGNORE:
-      return (unsigned long) (mask_NOIGNORE | MODI_INIT);
+      return (unsigned long) mask_NOIGNORE;
     case SH_LEVEL_USER0:
-      return (unsigned long) (mask_USER0 | MODI_INIT);
+      return (unsigned long) mask_USER0;
     case SH_LEVEL_USER1:
-      return (unsigned long) (mask_USER1 | MODI_INIT);
-    case SH_LEVEL_USER2:
-      return (unsigned long) (mask_USER2 | MODI_INIT);
-    case SH_LEVEL_USER3:
-      return (unsigned long) (mask_USER3 | MODI_INIT);
-    case SH_LEVEL_USER4:
-      return (unsigned long) (mask_USER4 | MODI_INIT);
+      return (unsigned long) mask_USER1;
     case SH_LEVEL_PRELINK:
-      return (unsigned long) (mask_PRELINK | MODI_INIT);
+      return (unsigned long) mask_PRELINK;
     default:
       return (unsigned long) 0;
@@ -1104,16 +679,10 @@
 {
   char * p;
-  char errbuf[SH_ERRBUF_SIZE];
 
   SL_ENTER(_("sh_files_globerr"));
-
-  if (errnum == ENOTDIR || errnum == ENOENT)
-    {
-      SL_RETURN(0, _("sh_files_globerr"));
-    }
 
   p = sh_util_safe_name (epath);
   sh_error_handle (SH_ERR_ERR, FIL__, __LINE__, errnum, MSG_FI_GLOB,
-		   sh_error_message (errnum, errbuf, sizeof(errbuf)), p);
+		   sh_error_message (errnum), p);
   SH_FREE(p);
 
@@ -1125,11 +694,9 @@
 #endif
 
-int sh_files_push_file_int (int class, const char * str_s, size_t len, 
-			    unsigned long check_flags)
+int sh_files_push_file_int (int class, const char * str_s, int len)
 {
   dirstack_t * new_item_ptr;
   char  * fileName;
   int     ret;
-  volatile int     count = 0;
 
   SL_ENTER(_("sh_files_push_file_int"));
@@ -1142,17 +709,16 @@
   new_item_ptr->name           = fileName;
   new_item_ptr->class          = class;
-  new_item_ptr->check_flags     = check_flags;
+  new_item_ptr->check_mask     = sh_files_maskof(class);
   new_item_ptr->rdepth         = 0;
   new_item_ptr->checked        = S_FALSE;
-  new_item_ptr->is_reported    = 0;
+  new_item_ptr->reported       = S_FALSE;
   new_item_ptr->childs_checked = S_FALSE;
 
-  SH_MUTEX_LOCK(mutex_zfiles);
   if (zfileList == NULL)
     {
-      zfileList = zAVLAllocTree (zdirstack_key, zAVL_KEY_STRING);
+      zfileList = zAVLAllocTree (zdirstack_key);
       if (zfileList == NULL) 
 	{
-	  (void) safe_logger (0, 0, NULL);
+	  (void) safe_logger (0, 0, getpid());
 	  aud__exit(FIL__, __LINE__, EXIT_FAILURE);
 	}
